;var yunyou = {};
yunyou["utils"] = {
	__utf16to8:function(str) {
		var out, i, len, c;
		out = "";
		len = str.length;
		for(i = 0; i < len; i++) {
			c = str.charCodeAt(i);
			if ((c >= 0x0001) && (c <= 0x007F)) {
				out += str.charAt(i);
			} else if (c > 0x07FF) {
				out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
				out += String.fromCharCode(0x80 | ((c >>  6) & 0x3F));
				out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
			} else {
				out += String.fromCharCode(0xC0 | ((c >>  6) & 0x1F));
				out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
			}
		}
		return out;
	},
	__utf8to16:function(str)
	{
		var out, i, len, c;
		var char2, char3;
		out = "";
		len = str.length;
		i = 0;
		while(i < len) {
			c = str.charCodeAt(i++);
			switch(c >> 4)
			{
			  case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
				// 0xxxxxxx
				out += str.charAt(i-1);
				break;
			  case 12: case 13:
				// 110x xxxx   10xx xxxx
				char2 = str.charCodeAt(i++);
				out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
				break;
			  case 14:
				// 1110 xxxx  10xx xxxx  10xx xxxx
				char2 = str.charCodeAt(i++);
				char3 = str.charCodeAt(i++);
				out += String.fromCharCode(((c & 0x0F) << 12) |
											   ((char2 & 0x3F) << 6) |
											   ((char3 & 0x3F) << 0));
				break;
			}
		}
		return out;
	} ,
	__encode64:function(input)
	{
		var keyStr = "ABCDEFGHIJKLMNOP" +
		"QRSTUVWXYZabcdef" +
		"ghijklmnopqrstuv" +
		"wxyz0123456789+/" +
		"=";
		//input = escape(input); 
		var output = ""; 
		var chr1, chr2, chr3 = ""; 
		var enc1, enc2, enc3, enc4 = ""; 
		var i = 0; 

		do
		{ 
		   chr1 = input.charCodeAt(i++); 
		   chr2 = input.charCodeAt(i++); 
		   chr3 = input.charCodeAt(i++); 
		  
		   enc1 = chr1 >> 2; 
		   enc2 = ((chr1 & 3) << 4) | (chr2 >> 4); 
		   enc3 = ((chr2 & 15) << 2) | (chr3 >> 6); 
		   enc4 = chr3 & 63; 
		  
		   if (isNaN(chr2))
		   {
			enc3 = enc4 = 64; 
		   }
		   else if (isNaN(chr3))
		   { 
			enc4 = 64; 
		   } 
		  
		   output = output + 
		   keyStr.charAt(enc1) + 
		   keyStr.charAt(enc2) + 
		   keyStr.charAt(enc3) + 
		   keyStr.charAt(enc4); 
		   chr1 = chr2 = chr3 = ""; 
		   enc1 = enc2 = enc3 = enc4 = ""; 
		} while (i < input.length); 

	return output; 
	},
	__decode64:function(input)
	{
	  var keyStr = "ABCDEFGHIJKLMNOP" +
			"QRSTUVWXYZabcdef" +
			"ghijklmnopqrstuv" +
			"wxyz0123456789+/" +
			"=";
	  var output = "";
	  var chr1, chr2, chr3 = "";
	  var enc1, enc2, enc3, enc4 = "";
	  var i = 0;
	  var base64test = /[^A-Za-z0-9\+\/\=]/g;
	  if (base64test.exec(input)) {
	  }
	  input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	  do {
		 enc1 = keyStr.indexOf(input.charAt(i++));
		 enc2 = keyStr.indexOf(input.charAt(i++));
		 enc3 = keyStr.indexOf(input.charAt(i++));
		 enc4 = keyStr.indexOf(input.charAt(i++));

		 chr1 = (enc1 << 2) | (enc2 >> 4);
		 chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
		 chr3 = ((enc3 & 3) << 6) | enc4;

		 output = output + String.fromCharCode(chr1);

		 if (enc3 != 64) {
			output = output + String.fromCharCode(chr2);
		 }
		 if (enc4 != 64) {
			output = output + String.fromCharCode(chr3);
		 }

		 chr1 = chr2 = chr3 = "";
		 enc1 = enc2 = enc3 = enc4 = "";
	  } while (i < input.length);
	  return output;
	  //return unescape(output);
	},
	trim: function( text ) {
		return (text || "").replace(/^(\s|\u00A0)+|(\s|\u00A0)+$/g, "" );
	},
	encodestr:function(str)
	{
		return this.__encode64(this.__utf16to8(str));
	},
	decodestr:function(str)
	{
		return this.__utf8to16(this.__decode64(str));
	},
	cookie : function(name, value, options)
	{
		if (typeof value != 'undefined') { // name and value given, set cookie
			options = options || {};
			if (value === null) {
				value = '';
				options.expires = -1;
			}
			var expires = '';
			if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
				var date;
				if (typeof options.expires == 'number') {
					date = new Date();
					date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
				} else {
					date = options.expires;
				}
				expires = '; expires=' + date.toUTCString();
			}
			var path = options.path ? '; path=' + (options.path) : '';
			var domain = options.domain ? '; domain=' + (options.domain) : '';
			var secure = options.secure ? '; secure' : '';
			document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
		} else {
			var cookieValue = null;
			if (document.cookie && document.cookie != '') {
				var cookies = document.cookie.split(';');
				for (var i = 0; i < cookies.length; i++) {
					var cookie = this.trim(cookies[i]);
					if (cookie.substring(0, name.length + 1) == (name + '=')) {
						cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
						break;
					}
				}
			}
			return cookieValue;
		}
	},
	getParameterFromUrl:function(name,string){
			var r = new RegExp("(\\?|#|&)"+name+"=([^&#]*)(&|#|$)");
			var m = string.match(r);
			return (!m?"":m[2]);
	},
	locationhash :function(val)
	{
		if(val){
			window.location.hash = "#"+val;
			return false;
		}else{
			return location.hash.substr(1);
		}
	}
};

yunyou["debug"] = {
	__debugOn:false,
	setDebug:function(res)
	{
		this.__debugOn = (res)?true:false;
	},
	w:function(key,value)
	{
		if(this.__debugOn)
		{
			if(!document.getElementById('debug_console'))
			{
				var oDiv=document.createElement("div");
				oDiv.id = "debug_console";
				oDiv.style.position = "absolute";
				oDiv.style.bottom = 0;
				oDiv.style.right=0;
				oDiv.style.backgroundColor = "#fff";
				oDiv.style.border = "1px solid #5F8EB0";
				oDiv.style.width = "300px";
				oDiv.style.height = "200px";
				oDiv.style.overflow = "auto";
				oDiv.style.zIndex = "999";
				document.body.appendChild(oDiv);
			}
			document.getElementById('debug_console').style.display = "";
			__cPrint_str = (value||value===0)?key+"="+value+";":key;
			var node = document.createElement("p");
			document.getElementById('debug_console').appendChild(node);
			node.style.padding = "3px 0";
			node.innerHTML = __cPrint_str;
		}
	}	
};

var js_apply = function ()
{
	var toString = Object.prototype.toString;
	var args = Array.prototype.slice.call(arguments);
	var request = args.shift();
	try{
		yunyou.debug.w(request+"[apply]",args);
		if(!connectProxy[request]) connectProxy[request] = {};
		reqFunc = connectProxy[request]["apply"];
		if(toString.call(reqFunc) !== "[object Function]")
		{
			connectProxy[request]["doing"] = false;
			reqFunc = function()
			{
				if(!connectProxy[request]["doing"])
				{
					try{
						connectProxy[request]["doing"] = true;
						var args2 = Array.prototype.slice.call(args);
						for(i in args2)
						{
							args2[i] = args2[i].replace(/\\/g,"\\\\");
							args2[i] = args2[i].replace(/\"/g,"\\\"");
						}
						var argsStr = '"'+args2.join('","')+'"';
						yunyou.debug.w(request+"[external]",argsStr);
						eval("window.external."+request+"("+argsStr+");");
						args2 = argsStr =  null;
					}catch(e){
						connectProxy[request]["doing"] = false;
					}
				}
			}
		}
		if(toString.call(connectProxy[request]["apply_before"]) === "[object Function]")
		{
			connectProxy[request]["apply_before"].apply(null,args);
		}
		if(toString.call(reqFunc) === "[object Function]")
		{
			reqFunc.apply(null,args);
		}
		if(toString.call(connectProxy[request]["apply_after"]) === "[object Function]")
		{
			connectProxy[request]["apply_after"].apply(null,args);
		}
	}catch(e){
		
	}
};
var js_callback = function ()
{
	var toString = Object.prototype.toString;
	var args = Array.prototype.slice.call(arguments);
	var request = args.shift();
	try{
		yunyou.debug.w(request+"[callback]",args);
		if(!connectProxy[request]) connectProxy[request] = {};
		reqFunc = connectProxy[request]["callback"];
		if(toString.call(reqFunc) !== "[object Function]")
		{
			connectProxy[request]["doing"] = false;
			reqFunc = function()
			{
				connectProxy[request]["doing"] = false;
			}
		}
		if(toString.call(connectProxy[request]["callback_before"]) === "[object Function]")
		{
			connectProxy[request]["callback_before"].apply(null,args);
		}
		if(toString.call(reqFunc) === "[object Function]")
		{
			reqFunc.apply(null,args);
		}
		if(toString.call(connectProxy[request]["callback_after"]) === "[object Function]")
		{
			connectProxy[request]["callback_after"].apply(null,args);
		}
	}catch(e){
		
	}
};

var connectProxy = {
	set_current_user:{
		callback:null,
		apply:(function()
		{
			var currNum = 1;
			return function(uid,uname)
			{
				setTimeout(function() {
					try{
						yunyou.debug.w("set_current_user!![apply]");
						yunyou.debug.w("set_current_user!!.apply[currNum]",currNum);
						window.external.set_current_user(uid,uname);
					}catch(e){
						yunyou.debug.w("no found set_current_user!!");
						if(currNum++<15)
						{
							setTimeout(arguments.callee, 300);
						}
					}
				}, 200);
			}
		})(),
		callback_after:function(res,uid)
		{
			if(res==="true")
			{
				yunyou.user.confirmAccess(uid);
				if(connectProxy.set_current_user.callback)
				{
					connectProxy.set_current_user.callback();
				}
			}
		}
	},
	logout:{
		callback:null,
		apply:(function()
		{
			var currNum = 1;
			return function()
			{
				setTimeout(function() {
					try{
						yunyou.debug.w("logout!![apply]");
						yunyou.debug.w("logout!!.apply[currNum]",currNum);
						window.external.logout();
					}catch(e){
						yunyou.debug.w("no found logout!!");
						if(currNum++<15)
						{
							setTimeout(arguments.callee, 300);
						}
					}
				}, 200);
			}
		})(),
		callback_after:function(res)
		{
			if(res==="true")
			{
				yunyou.user.cancelAccess();
				if(connectProxy.logout.callback)
				{
					connectProxy.logout.callback();
				}
			}
		}
	}
};

yunyou["user"] = {
	__formatAccessCookie:function(uid)
	{
		return "yy_"+uid+"_acct";
	},
	checkAccess:function(uid,uname,callback)
	{
		var r = yunyou.utils.cookie(this.__formatAccessCookie(uid))
		uname = yunyou.utils.encodestr(uname);
		if(callback)
		{
			connectProxy.set_current_user.callback = callback;
		}
		js_apply("set_current_user",uid,uname);
	},
	confirmAccess:function(uid)
	{
		yunyou.utils.cookie(this.__formatAccessCookie(uid),"done");
		yunyou.utils.cookie("yy_current_uid",uid);
		yunyou.debug.w("confrimAccess[uid="+uid+"]");
	},
	cancelAccess:function()
	{
		if(yunyou.utils.cookie("yy_current_uid"))
		{
			var uid = yunyou.utils.cookie("yy_current_uid");
			yunyou.utils.cookie(this.__formatAccessCookie(uid),"null");
			yunyou.utils.cookie("yy_current_uid",0);
			yunyou.debug.w("cancelAccess[uid="+uid+"]");
		}		
	},
	logout:function(callback)
	{
		if(callback)
		{
			connectProxy.logout.callback = callback;
		}
		js_apply("logout");
	}
};

yunyou["svc"] = {
	userAccess:function(uid,uname,callback){
		yunyou.debug.w("userAccess",uid+","+uname);
		yunyou.user.checkAccess(uid,uname,callback);	
	},
	userLogout:function(callback)
	{
		yunyou.debug.w("userLogout");
		yunyou.user.logout(callback);
	}
};